package jp.usapyonsoft.lesserpyon;
import java.util.Vector;

class SikouMT implements Constants,Runnable {
  static final int MT_NOT_RUN=222222222;
  int ThreadID;
  Sikou s;
  Kyokumen k;
  Te te;
  int alpha,beta;
  int depth,depthMax;
  volatile boolean waiting;
  volatile int value;
  volatile int destroying;
  volatile boolean processed;

  Thread MT;

  public SikouMT(int ThreadID,Sikou s) {
    this.ThreadID=ThreadID;
    this.s=s;
    waiting=true;
    MT=new Thread(this);
//    MT.setDaemon(true);
    value=MT_NOT_RUN;
    destroying=0;
    processed=false;
    MT.start();
  }

  public void run() {
    Run();
  }

  public synchronized void Run() {
    for(;destroying!=1;) {
      try {
        wait();
//        System.out.println("Sub "+ThreadID+"Run.");
      } catch(InterruptedException ie) {
        ie.printStackTrace();
      }
      waiting=false;
      processed=false;
      Te tmpTe=new Te(0,0,0,false,0);
      s.stackMT[ThreadID][depth]=te;

      s.kkStack[ThreadID][depth]=(Kyokumen)k.clone();

      k.move(te);
      if (k.teban==SENTE) {
        k.teban=GOTE;
      } else {
        k.teban=SENTE;
      }
      value=-s.negaMax(tmpTe,k,-beta,-alpha,depth+1,depthMax,ThreadID,true);
      // k.back()͂ȂĂǂ
      waiting=true;
      processed=true;
//      System.out.println("Sub "+ThreadID+" to Main Resume.");
      s.waitObj.Resume();
    }
  }

  public synchronized void doRun() {
//    System.out.println("Sub "+ThreadID+" doRun.");
    notify();
//    System.out.println("Sub "+ThreadID+" doRun Notified.");
  }

  public boolean isRunning() {
    return !processed;
  }
}

// Rs[^̎vl[`
public class Sikou implements Player,Constants,Runnable {
  // \߂̒萔
  static final int INFINITE=99999999;

  static final int STOPPED=111111111;

  // ǂ݂̍ő[cȏ̓ǂ݂͐΂ɕs\B
  static final int LIMIT_DEPTH=16;

  // }`XbhpWorkArea Start
  static final int MaxThread=4;
  SikouMT sikouMT[]=new SikouMT[MaxThread+1];

  // őP菇i[z
  public Te bestMT[][][]=new Te[MaxThread+1][LIMIT_DEPTH][LIMIT_DEPTH];
  // ܂ł̒T菇i[z
  public Te stackMT[][]=new Te[MaxThread+1][LIMIT_DEPTH];
  // TransPositionTabléAXbhŋ

  // w̕]xŎg̔z
  Te teSMT[][]=new Te[MaxThread+1][20];
  // 葤
  Te teEMT[][]=new Te[MaxThread+1][20];

  // ǖ
  Kyokumen kkMT[]=new KyokumenKomagumi[MaxThread+1];

  // fobOpǖ
  Kyokumen kkStack[][]=new Kyokumen[MaxThread+1][LIMIT_DEPTH];

  // vl~߂B
  volatile boolean stopMT[]=new boolean[MaxThread+1];

  class Resume {
    synchronized void Wait() {
      try {
        wait();
      }catch(InterruptedException ie) {
        // [cB
        ie.printStackTrace();
      }
    }
    synchronized void Resume() {
      notify();
    }
  }
  public Resume waitObj=new Resume();
  // }`XbhpWorkArea End

  // ǂ݂̐[
  static final int DEPTH_MAX=6;

  // őǂݎ萔
  static final int teMax[]={50,50,32,32,24,24,16,16,16,16,16,16,16,16,16,16};

  // ̎vlpTransPositionTable
  TranspositionTable tt=new TranspositionTable();

  // ǂ݋؁iro߁jo͂邩
  boolean doOutput=true;

  int leaf=0;
  int node=0;

  // ՂΒՂ𗘗pB
  Joseki joseki;

  // Ŏvl邽߂̔
  KyokumenKomagumi kk;

  // \ǂ݂Jn
  KyokumenKomagumi yosoku;

  // \ǂ݂Xbh
  Thread sikou_ura;

  // w̕]xŎg̔z
  /*
  Te teS[]={
    new Te(),new Te(),new Te(),new Te(),new Te(),
    new Te(),new Te(),new Te(),new Te(),new Te(),
    new Te(),new Te(),new Te(),new Te(),new Te(),
    new Te(),new Te(),new Te(),new Te(),new Te()
  };
  // 葤
  Te teE[]={
    new Te(),new Te(),new Te(),new Te(),new Te(),
    new Te(),new Te(),new Te(),new Te(),new Te(),
    new Te(),new Te(),new Te(),new Te(),new Te(),
    new Te(),new Te(),new Te(),new Te(),new Te()
  };
  */

  // vl~߂B
  volatile boolean stopped;

  // vlIĂB
  volatile boolean processed;

  // vlJn
  long time;

  long sikoutime;

  public Sikou() {
    joseki=new Joseki("joseki.bin");
    for(int i=0;i<MaxThread+1;i++) {
      for(int j=0;j<20;j++) {
        teSMT[i][j]=new Te();
        teEMT[i][j]=new Te();
      }
      kkMT[i]=new KyokumenKomagumi();
      if (i>=1) {
        sikouMT[i]=new SikouMT(i,this);
      }
    }
  }

  int min(int x,int y) {
    if (x<y) return x;
    return y;
  }

  int negaMax(Te t,Kyokumen k,int alpha,int beta,int depth,int depthMax,
      int ThreadID,boolean bITDeep) {
    // [ő[ɒBĂ炻ł̕]lԂďIB
    if (depth>=depthMax) {
      leaf++;
      if (k.teban==SENTE) {
        return k.evaluate();
      } else {
        return -k.evaluate();
      }
    }
    if (stopMT[ThreadID]) {
      return STOPPED;
    }
    node++;
    TTEntry e=tt.get(k.HashVal);

    if (e!=null) {
      if (e.value>=beta && e.depth<=depth && e.remainDepth>=depthMax-depth &&
          e.flag!=TTEntry.UPPER_BOUND) {
        return e.value;
      }
      if (e.value==INFINITE) {
        return e.value;
      }
      if (e.value<=alpha && e.depth<=depth && e.remainDepth>=depthMax-depth &&
          e.flag!=TTEntry.LOWER_BOUND) {
        return e.value;
      }
      if (e.value==-INFINITE) {
        return e.value;
      }
    }
    if (e==null && depthMax-depth>2 && bITDeep) {
      return ITDeep(k,alpha,beta,depth,depthMax,ThreadID);
    }

    // ݂̎w̌̕]lB
    int value=-INFINITE;

    // ŏɌy̐Ă݂B
    Vector v=GenerateMoves.makeMoveFirst(k,depth,this,e,ThreadID);

    // MakeMoveFirstŎ肪ꂽH
    boolean bMMF=false;
    if (v.size()>0) {
      bMMF=true;
    }

    for(int i=0;i<v.size();i++) {
      // @oB
      Te te=(Te)v.elementAt(i);

      // ̎ňi߂B
      kkStack[ThreadID][depth]=(Kyokumen)k.clone();
      stackMT[ThreadID][depth]=(Te)te.clone();
      k.move(te);
      // moveł́AւȂ̂ŁcB
      if (k.teban==SENTE) {
        k.teban=GOTE;
      } else {
        k.teban=SENTE;
      }

      // ̋ǖʂ̕]lAɐǂ݂ēB
      Te tmpTe=new Te(0,0,0,false,0);
      int eval=-negaMax(tmpTe,k,-beta,-alpha,depth+1,depthMax,ThreadID,true);
      k.back(te);
      // backł́AւȂ̂ŁcB
      if (k.teban==SENTE) {
        k.teban=GOTE;
      } else {
        k.teban=SENTE;
      }
      if (eval==STOPPED || eval==-STOPPED) {
        return STOPPED;
      }
      if (stopMT[ThreadID]) return STOPPED;

      // wŐi߂ǖʂA܂łƑ傫ȒlԂH
      if (eval>value) {
        // ԂlXV
        value=eval;
        // lXV
        if (eval>alpha) {
          alpha=eval;
        }
        // őPXV
        bestMT[ThreadID][depth][depth]=te;
        t.koma   =te.koma;
        t.from   =te.from;
        t.to     =te.to;
        t.promote=te.promote;
        // őP菇XV
        for(int j=depth+1;j<depthMax;j++) {
          bestMT[ThreadID][depth][j]=bestMT[ThreadID][depth+1][j];
        }
        if (depth==0 && doOutput) {
          System.out.print("oߎ"+(System.currentTimeMillis()-time)+"ms  ]l:"+value);
          System.out.print("  őP菇:");
          for(int j=0;j<depthMax;j++) {
            System.out.print(bestMT[0][0][j]);
          }
          System.out.println();
        }
        // Jbg̏𖞂ĂA[vIB
        if (eval>=beta) {
          tt.add(k.HashVal,value,alpha,beta,bestMT[ThreadID][depth][depth],
              depth,depthMax-depth,0);
          return eval;
        }
      }
      if (depth==0 && value>-INFINITE && System.currentTimeMillis()-time>sikoutime) {
        return STOPPED;
      }
    }

    // ݂̋ǖʂł̍@𐶐
    v=GenerateMoves.generateLegalMoves(k);

    GenerateMoves.evaluateTe(k,v,teSMT[ThreadID],teEMT[ThreadID]);

    // @̒AwĂ݂āAԂ悩wIB
    for(int i=0;i<v.size();i++) {
      if ( (i==0 && !bMMF) || depthMax-depth<1 || depth==0) {
        // ʏ̒T
      } else if (ThreadID==0 && depthMax-depth>1) {
        // T
        for(;i<v.size() && (i<teMax[depth] || value==-INFINITE);) {
          int thID=1;
          for(;i<v.size() && thID<MaxThread+1 && (i<teMax[depth] || value==-INFINITE) ;i++,thID++) {
            Te te=(Te)v.elementAt(i);
            // ĂXbhɏ𓊂
            if (sikouMT[thID].waiting) {
              stopMT[thID]=false;
              kkMT[thID]=new KyokumenKomagumi(k);
              for(int stDepth=0;stDepth<depth;stDepth++) {
                stackMT[thID][stDepth]=stackMT[0][stDepth];
              }
              sikouMT[thID].k=kkMT[thID];
              sikouMT[thID].depth=depth;
              sikouMT[thID].depthMax=depthMax;
              sikouMT[thID].te=(Te)te.clone();

              if (!sikouMT[thID].te.equals(te)) {
            	  System.out.println("--------------------");
            	  System.out.println("te="+te.toString());
            	  System.out.println("cl="+sikouMT[thID].te.toString());
            	  System.out.println("--------------------");
              }

              sikouMT[thID].alpha=alpha;
              sikouMT[thID].beta=beta;
              sikouMT[thID].doRun();
            }
          }
          // ŁAWaitForMultipleObject̃m~B

          // 댯ȓc
          synchronized (waitObj) {
            for(int waitTh=1;waitTh<MaxThread+1;waitTh++) {
              if (sikouMT[waitTh].isRunning()) {
                waitObj.Wait();
                break;
              }
            }
          }
          // ʂԂėĂ
          for(int endMT=1;endMT<MaxThread+1;endMT++) {
            // 댯HH
            if (sikouMT[endMT].processed) {
//              System.out.println("proc "+endMT+" end.");
              //
              if (sikouMT[endMT].value!=STOPPED && sikouMT[endMT].value>value) {
                // ԂlXV
                int eval=sikouMT[endMT].value;
                if (eval==STOPPED || eval==-STOPPED) {
                  // SXbh~
                  for (int ID=1;ID<MaxThread+1;ID++) {
                    stopMT[ID]=true;
                  }
                  return STOPPED;
                }
                // lXV
                if (eval>alpha) {
                  alpha=eval;
                }
                // őPXV
                bestMT[ThreadID][depth][depth]=sikouMT[endMT].te;
                t.koma   =sikouMT[endMT].te.koma;
                t.from   =sikouMT[endMT].te.from;
                t.to     =sikouMT[endMT].te.to;
                t.promote=sikouMT[endMT].te.promote;
                // őP菇XV
                for(int j=depth+1;j<depthMax;j++) {
                  bestMT[ThreadID][depth][j]=bestMT[endMT][depth+1][j];
                }
                // Jbg̏𖞂ĂA[vIB
                if (eval>=beta) {
                  tt.add(k.HashVal,eval,alpha,beta,bestMT[ThreadID][depth][depth],
                      depth,depthMax-depth,0);
                  // SXbh~
                  for (int ID=1;ID<MaxThread+1;ID++) {
                    stopMT[ID]=true;
                  }
                  break;
                }
              }
            }
          }
          boolean doBreak=true;
          for(int workingMT=1;workingMT<MaxThread+1;workingMT++) {
            if (sikouMT[workingMT].processed==false) {
              doBreak=false;
            }
          }
          if (doBreak) {
            break;
          }
          // ēx𓊂郋[vցB
        }
      }
      // @oB
      Te te=null;
      if (i<v.size()) {
        te=(Te)v.elementAt(i);
        if ((te.value<-100 || i>teMax[depth]) && value>-INFINITE) {
          break;
        }
      }

      if (te==null) {
        break;
      }
      // ̎ňi߂B
      kkStack[ThreadID][depth]=(Kyokumen)k.clone();
      stackMT[ThreadID][depth]=te;
      k.move(te);
      // moveł́AւȂ̂ŁcB
      if (k.teban==SENTE) {
        k.teban=GOTE;
      } else {
        k.teban=SENTE;
      }

      // ̋ǖʂ̕]lAɐǂ݂ēB
      Te tmpTe=new Te(0,0,0,false,0);
      int eval=-negaMax(tmpTe,k,-beta,-alpha,depth+1,depthMax,ThreadID,true);
      if (eval==STOPPED || eval==-STOPPED) {
        return STOPPED;
      }
      k.back(te);
      if (depth>1 && te.to==stackMT[ThreadID][depth-1].to && stackMT[ThreadID][depth-1].value2<-100 && eval<beta) {
        // ʂc
        // T
        k.move(te);
        int enchou=-negaMax(tmpTe,k,-beta,-beta+1,depth+1,min(depthMax+2,LIMIT_DEPTH),ThreadID,true);
        if (enchou>beta) {
          eval=enchou;
          if (eval==STOPPED || eval==-STOPPED) {
            return STOPPED;
          }
        }
        k.back(te);
      }
      if (stopMT[ThreadID]) return STOPPED;
      // backł́AւȂ̂ŁcB
      if (k.teban==SENTE) {
        k.teban=GOTE;
      } else {
        k.teban=SENTE;
      }

      // wŐi߂ǖʂA܂łƑ傫ȒlԂH
      if (eval>value) {
        // ԂlXV
        value=eval;
        // lXV
        if (eval>alpha) {
          alpha=eval;
        }
        // őPXV
        bestMT[ThreadID][depth][depth]=te;
        t.koma   =te.koma;
        t.from   =te.from;
        t.to     =te.to;
        t.promote=te.promote;
        // őP菇XV
        for(int j=depth+1;j<depthMax;j++) {
          bestMT[ThreadID][depth][j]=bestMT[ThreadID][depth+1][j];
        }
        if (depth==0 && doOutput) {
          System.out.print("oߎ"+(System.currentTimeMillis()-time)+"ms  ]l:"+value);
          System.out.print("  őP菇:");
          for(int j=0;j<depthMax;j++) {
            System.out.print(bestMT[0][0][j]);
          }
          System.out.println();
        }
        // Jbg̏𖞂ĂA[vIB
        if (eval>=beta) {
          break;
        }
      }
      if (depth==0 && value>-INFINITE && System.currentTimeMillis()-time>sikoutime) {
        break;
      }
    }
    tt.add(k.HashVal,value,alpha,beta,bestMT[ThreadID][depth][depth],
        depth,depthMax-depth,0);
    return value;
  }

  int ITDeep(Kyokumen k,int alpha,int beta,int depth,int depthMax,int ThreadID) {
    if (depth==0) {
      time=System.currentTimeMillis();
    }
    int retval=-INFINITE;
    int i;
    Te te=new Te(0,0,0,false,0);
    for(i=depth+1;i<=depthMax && !stopMT[ThreadID] ;i++) {
      retval=negaMax(te,k,alpha,beta,depth,i,ThreadID,false);
      if (depth==0 && System.currentTimeMillis()-time>sikoutime) {
        break;
      }
    }
    if (depth==0) {
      if (stopMT[ThreadID]) {
        stopMT[ThreadID]=false;
        stopped=true;
      } else {
        processed=true;
      }
    }
    return retval;
  }

  public Te getNextTe(Kyokumen k,int tesu,int spenttime,int limittime,int byoyomi) {
    leaf=node=0;

    Te te;

    // 25؂ꕉ̐ݒ
    /*
    if (limittime-spenttime<120) {
      sikoutime=1800; // 1.8b
    } else if (limittime-spenttime<180) {
      sikoutime=18000; // 18b
    } else {
      sikoutime=40000; // 40b
    }
    */
    // floodgate-600-10p
    int byoyomiMargin=2000;
    if (limittime-spenttime<20) {
      sikoutime=byoyomi*1000-byoyomiMargin;
    } else {
      sikoutime=20000; // 20b
    }


    if ((te=joseki.fromJoseki(k,tesu))!=null) {
      System.out.println("Ղ:"+te.toString());
      return te;
    }

    if (yosoku!=null && yosoku.equals(k)) {
      // \Ă̂ŁÂ܂ܐi߂B
      System.out.println("\");
      doOutput=true;
      while(!processed) {
        try {
          Thread.sleep(100);
        }catch(Exception e){
        }
      }
      te=bestMT[0][0][0];
    } else {
      if (sikou_ura!=null && !processed) {
        stopMT[0]=true;
        while(!stopped) {
          try {
            Thread.sleep(100);
          }catch(Exception e){
          }
        }
      }
      kkMT[0]=new KyokumenKomagumi(k);

      // ]lő̎𓾂
      // ɂ悤ȎŏB
      doOutput=true;
      te=new Te(0,0,0,false,0);
      int v=ITDeep(kkMT[0],-INFINITE,INFINITE,0,DEPTH_MAX,0);
      if (v>-INFINITE) {
        te=bestMT[0][0][0];
      }
    }
    System.out.print("  őP菇:");
    for(int i=0;i<DEPTH_MAX;i++) {
      System.out.print(bestMT[0][0][i]);
    }
    System.out.println();

    time=System.currentTimeMillis()-time;
    System.out.println("leaf="+leaf+" node="+node+" time="+time+"ms");

    // ̎ƁA\̎Őɐi߂B
    if (bestMT[0][0][0]==null || bestMT[0][0][1]==null) {
      // lłAȂǁB
    } else {
      kkMT[0].move(bestMT[0][0][0]);
      kkMT[0].move(bestMT[0][0][1]);
      yosoku=new KyokumenKomagumi((Kyokumen)kkMT[0].clone());
      sikou_ura=new Thread(this);
      sikou_ura.start();
    }

    return te;
  }

  // ̎vlɍlB
  public void run() {
    processed=false;
    stopMT[0]=false;
    stopped=false;
    doOutput=false;
    int v=ITDeep(kkMT[0],-INFINITE,INFINITE,0,DEPTH_MAX,0);
    sikou_ura=null;
  }
}
